3 FOR i=0 TO PI*2 STEP PI/24 : PRINT i,TAN(i),FTAN(i)
4 STOP
100 REMark Tester for FPUfns version 1.4
110 REMark Simon N Goodwin December 1996
115 REMark & Mark J Swift, February 1997
120 REMark Needs DIY Toolkit TIMING_CODE
121 :
122 LRESPR "flp1_TIMING_code"
123 LRESPR "flp1_FPSAVE_bin"
124 LRESPR "flp1_fpufns_TEST_code"
125 :
126 PRINT "Load the FPUfns and FPSP, then"
127 PRINT "enter TIME_FP <loops> to test."
128 PRINT
129 PAUSE 200
130 :
135 OPEN#4;"SCR_512x256a0x0"
140 REMark or BAUD 19200:OPEN#4;"SER1HN"
145 :
150 REMark MODE -126,-1
155 TIME_FP 50000
160 REMark MODE -126,-1
165 BEEP 0,0,3,400,79
170 :
175 CLOSE#4
177 STOP
179 :
180 DEFine PROCedure TIME_FP(tries)
190 PRINT#4
200 PRINT#4;"Testing over"!tries!"iterations"
202 T_ON
203 PRINT#4\"Timings started at ";DATE$
210 T_START:FOR i=1 TO tries:q=FNULL(i/tries)
220 absTime=T_COUNT/50
230 PRINT#4;"BASIC loop overhead ";absTime; " seconds"
240 PRINT#4
250 IF absTime<8
260 PRINT#4;"Not enough iterations for percentage"
270 PRINT#4;"accuracy - ";
280 PRINT#4;"try"!INT(20+tries*8/absTime)!"or more."
290 RETurn 
300 END IF 
310 REMark Test SIN against FSIN 'tries' times, etc.
330 PRINT#4\"Testing Sine function SIN"
340 T_START:FOR i=1 TO tries:q=FSIN(i/tries)
350 fsinTime=T_COUNT/50
360 PRINT#4;"FPU ";fsinTime;
370 T_START:FOR i=1 TO tries:q=SIN(i/tries)
380 sinTime=T_COUNT/50
390 PRINT#4;" CPU"!sinTime;
410 RANGE absTime,sinTime,fsinTime
420 :
430 PRINT#4\"Testing Cosine function COS"
440 T_START:FOR i=1 TO tries:q=FCOS(i/tries)
450 fcosTime=T_COUNT/50
460 PRINT#4;"FPU"!fcosTime;
470 T_START:FOR i=1 TO tries:q=COS(i/tries)
480 cosTime=T_COUNT/50
490 PRINT#4;" CPU"!cosTime;
510 RANGE absTime,cosTime,fcosTime
520 :
530 PRINT#4\"Testing Exponential function EXP"
540 T_START:FOR i=1 TO tries:q=FEXP(i/tries)
550 fexpTime=T_COUNT/50
560 PRINT#4;"FPU"!fexpTime;
570 T_START:FOR i=1 TO tries:q=EXP(i/tries)
580 expTime=T_COUNT/50
590 PRINT#4;" CPU"!expTime;
610 RANGE absTime,expTime,fexpTime
620 :
630 PRINT#4\"Testing Square Root function SQRT"
640 T_START:FOR i=1 TO tries:q=FSQRT(i/tries)
650 fsqrtTime=T_COUNT/50
660 PRINT#4;"FPU"!fsqrtTime;
670 T_START:FOR i=1 TO tries:q=SQRT(i/tries)
680 sqrtTime=T_COUNT/50
690 PRINT#4;" CPU"!sqrtTime;
710 RANGE absTime,sqrtTime,fsqrtTime
720 :
730 PRINT#4\"Testing Tangent function TAN"
740 T_START:FOR i=1 TO tries:q=FTAN(i/tries)
750 ftanTime=T_COUNT/50
760 PRINT#4;"FPU"!ftanTime;
770 T_START:FOR i=1 TO tries:q=TAN(i/tries)
780 tanTime=T_COUNT/50
790 PRINT#4;" CPU"!tanTime;
810 RANGE absTime,tanTime,ftanTime
820 :
830 PRINT#4\"Testing Cotangent function COT"
840 T_START:FOR i=1 TO tries:q=FCOT(i/tries)
850 fcotTime=T_COUNT/50
860 PRINT#4;"FPU"!fsinTime;
870 T_START:FOR i=1 TO tries:q=COT(i/tries)
880 cotTime=T_COUNT/50
890 PRINT#4;" CPU"!cotTime;
910 RANGE absTime,cotTime,fcotTime
920 :
930 PRINT#4\"Testing Arctangent function ATN"
940 T_START:FOR i=1 TO tries:q=FATAN(i/tries)
950 fatanTime=T_COUNT/50
960 PRINT#4;"FPU"!fatanTime;
970 T_START:FOR i=1 TO tries:q=ATAN(i/tries)
980 atanTime=T_COUNT/50
990 PRINT#4;" CPU"!atanTime;
1010 RANGE absTime,atanTime,fatanTime
1020 :
1030 PRINT#4\"Testing Arcsine function ASIN"
1040 T_START:FOR i=1 TO tries:q=FASIN(i/tries)
1050 fAsinTime=T_COUNT/50
1060 PRINT#4;"FPU"!fAsinTime;
1070 T_START:FOR i=1 TO tries:q=ASIN(i/tries)
1080 AsinTime=T_COUNT/50
1090 PRINT#4;" CPU"!AsinTime;
1110 RANGE absTime,AsinTime,fAsinTime
1120 :
1130 PRINT#4\"Testing ArcCoTangent function ACOT"
1140 T_START:FOR i=1 TO tries:q=FACOT(i/tries)
1150 facotTime=T_COUNT/50
1160 PRINT#4;"FPU"!facotTime;
1170 T_START:FOR i=1 TO tries:q=ACOT(i/tries)
1180 acotTime=T_COUNT/50
1190 PRINT#4;" CPU"!acotTime;
1210 RANGE absTime,acotTime,facotTime
1220 :
1230 PRINT#4\"Testing ArcCosine function ACOS"
1240 T_START:FOR i=1 TO tries:q=FACOS(i/tries)
1250 facosTime=T_COUNT/50
1260 PRINT#4;"FPU"!facosTime;
1270 T_START:FOR i=1 TO tries:q=ACOS(i/tries)
1280 acosTime=T_COUNT/50
1290 PRINT#4;" CPU"!acosTime;
1310 RANGE absTime,acosTime,facosTime
1320 :
1330 PRINT#4\"Testing Natural Logarithm function LN"
1340 T_START:FOR i=1 TO tries:q=FLN(i/tries)
1350 flnTime=T_COUNT/50
1360 PRINT#4;"FPU"!flnTime;
1370 T_START:FOR i=1 TO tries:q=LN(i/tries)
1380 lnTime=T_COUNT/50
1390 PRINT#4;" CPU"!lnTime;
1410 RANGE absTime,lnTime,flnTime
1420 :
1430 PRINT#4\"Testing Decimal Logarithm function LOG10"
1440 T_START:FOR i=1 TO tries:q=FLOG10(i/tries)
1450 flog10Time=T_COUNT/50
1460 PRINT#4;"FPU"!flog10Time;
1470 T_START:FOR i=1 TO tries:q=LOG10(i/tries)
1480 log10Time=T_COUNT/50
1490 PRINT#4;" CPU"!log10Time;
1510 RANGE absTime,log10Time,flog10Time
1520 PRINT#4\"Timings completed at ";DATE$
1530 END DEFine TIME_FP
1531 :
1532 DEFine PROCedure RANGE(a,p,f)
1533  IF (f-a)<=2/50 THEN 
1534   PRINT#4;"result unreliable"
1535  ELSE 
1536   v=INT(.5+100*(p-a)/(f-a))
1537   mnv=100*(p-a-2/50)/(f-a+2/50)
1538   mxv=100*(p-a+2/50)/(f-a-2/50)
1539   e=v-mnv
1540   IF (mxv-v)>e THEN e=mxv-v
1541   PRINT#4;" FPU boost within [";INT(mnv);"% to ";-INT(-mxv);"%] approx = ";v;"% (error < ";-INT(-e*100)/100;"%)"
1542  END IF 
1543 END DEFine 
1544 :
1550 DEFine PROCedure s
1560 SAVE_O "flp1_FPU_times_bas"
1570 END DEFine 

